/*
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */
package org.codehaus.groovy.util

import groovy.test.GroovyTestCase

class ManagedConcurrentValueMapTest extends GroovyTestCase {

    ManagedConcurrentValueMap<String, Object> map =
            new ManagedConcurrentValueMap<String, Object>(ReferenceBundle.getHardBundle())

    void testEntriesRemoveSelfFromMapWhenFinalized() {
        for (int i = 0; i < 5; i++) {
            map.put("Key${i}", new Object())
        }

        assert map.@internalMap.size() == 5

        Collection<ManagedReference<Object>> values = map.@internalMap.values()
        values*.finalizeReference()

        assert map.@internalMap.size() == 0
    }
}
